package com.mkyong;

import java.util.Locale;

import org.apache.wicket.util.file.IResourceFinder;
import org.apache.wicket.util.resource.IResourceStream;
import org.apache.wicket.util.resource.locator.ResourceStreamLocator;
import org.apache.wicket.util.string.Strings;

public class MyOwnFinderStreamLocator extends ResourceStreamLocator
{

	private IResourceFinder resourceFinder;
	
	public void addFinder(IResourceFinder resourceFinder) {
		if (resourceFinder != null) {
			this.resourceFinder = resourceFinder;
		}
	}
	
	@Override
	public IResourceStream locate(Class<?> clazz, String path, String style,
			Locale locale, String extension) {
		
		String simpleFileName = Strings.lastPathComponent(clazz.getName(), '.') + "." + extension;
		
		IResourceStream stream = locate(clazz, simpleFileName);
		
		if(stream!=null)
			return stream;
		else
			return super.locate(clazz, path,style,locale,extension);
		
	}
	
	@Override
	protected IResourceStream locateByResourceFinder(Class<?> clazz, String path) {
		IResourceStream resourceStream = null;
		
		resourceStream = resourceFinder.find(clazz, path);
			
		if (resourceStream == null) {
			// try by using class loader
			resourceStream = locateByClassLoader(clazz, path);
		}

		return resourceStream;
	}
}



